;************************************************************************
;*                      Fast BlueBox Effects via ASM                    *
;*                    This code is used from a VB Call                  *
;*                           by Daniel Aue 01.2005                      *
;*                                                                      *
;*                     USE ENTIRELY AT YOUR OWN RISK.                   *
;*                 you may publish this source as long as               *
;*                      this commentblock stays in                      *
;************************************************************************
      .386
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive

    .code

pSource         EQU <DWORD Ptr [ebp]>
pDest           EQU <DWORD Ptr [ebp+4]>
pMask           EQU <DWORD Ptr [ebp+8]>
pColRange       EQU <DWORD Ptr [ebp+12]>
dwHeight        EQU <DWORD Ptr [ebp+16]>
dwWidth         EQU <DWORD Ptr [ebp+20]>
dwPadBytes      EQU <DWORD Ptr [ebp+24]>

    ;EDI=Byte Offset ins Bild
    ;ESI=Mask Bitmap
    ;EBX=Source Bitmap
    ;EDX=ColRange/Dest Bitmap
    ;ECX=WidthCounter

main:
    push    ebp
    mov     ebp,esp
    push    edi
    push    esi
    push    ebx

    mov     ebp,[ebp+8]     ;get Pointer to Parameter Struct

    xor edi,edi
    mov esi,pMask
    mov ebx,pSource
    mov edx,pColRange

NextLine:
    mov ecx,dwWidth
            

NextPixel:

    mov al,[esi + edi]  ;Blau Wert aus dem Masken BMP holen
    cmp al,[edx]        ;mit BlueLow vergleichen
    jb  noMatch
    cmp al,[edx+1]      ;mit BlueHigh vergleichen
    ja  noMatch

    mov al,[esi + edi+1]  ;Grn Wert aus dem Masken BMP holen
    cmp al,[edx+2]      ;mit GreenLow vergleichen
    jb  noMatch
    cmp al,[edx+3]      ;mit GreenHigh vergleichen
    ja  noMatch

    mov al,[esi + edi+2]  ;Rot Wert aus dem Masken BMP holen
    cmp al,[edx+4]      ;mit RedLow vergleichen
    jb  noMatch
    cmp al,[edx+5]      ;mit RedHigh vergleichen
    ja  noMatch

    ; *** alle haben gepasst
    mov edx,pDest
    mov al,[ebx+edi]  ;Source Byte Blau auslesen
    mov [edx+edi],al  ;und in Dest schreiben
    mov al,[ebx+edi+1]  ;Source Byte Grn auslesen  
    mov [edx+edi+1],al  ;und in Dest schreiben
    mov al,[ebx+edi+2]    ;Source Byte Rot auslesen
    mov [edx+edi+2],al    ;und in Dest schreiben
    mov edx, pColRange

noMatch:
    add edi,3   ;auf nchsten Pixel setzen

    dec ecx
    ja NextPixel
    add edi,[dwPadBytes]
    dec DWORD PTR [dwHeight]
    ja NextLine

    pop ebx
    pop esi
    pop edi
    pop ebp
    xor eax,eax
    ret 16

end main
